# coding:utf-8
import getpass
import subprocess as subs
import crypt
import csv
import logging

logging.basicConfig(level=logging.INFO)


def insert(file, file_data):
    with open(file, "w", encoding="utf-8") as f:
        f.write(file_data)


# Replaces the string in the file


def alter(file, oldStr, newStr):
    file_data = ""

    try:
        file_data = alterInsert(file, oldStr, newStr)

    except FileNotFoundError:
        logging.info("The file does not exist")
        pass
    insert(file, file_data)


def alterInsert(file, oldStr, newStr):
    file_data = ""
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if oldStr in line:
                line = line.replace(oldStr, newStr)
            file_data += line
    return file_data


def alterAfter(file, findStr, newStr):
    file_data = ""
    try:
        file_data = alterAfterInsert(file, findStr, newStr)
    except FileNotFoundError:
        logging.info("The file does not exist")
        return
    insert(file, file_data)


def alterAfterInsert(file, findStr, newStr):
    file_data = ''
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if findStr in line:
                begin = line[:line.find(findStr)]
                line = begin + findStr + newStr
            file_data += line
    return file_data


def addAfter(file, findStr, newStr):
    file_data = ""
    try:
        file_data = addAfterInsert(file, findStr, newStr)

    except FileNotFoundError:
        logging.info("The file does not exist")
        pass
    insert(file, file_data)


def addAfterInsert(file, findStr, newStr):
    file_data = ""
    with open(file, "r", encoding="utf-8") as f:
        for line in f:
            if findStr in line:
                file_data += line
                file_data += newStr
                continue
            file_data += line
    return file_data


def readCsv(filename):
    dic = {}
    li = []
    with open(filename, newline='') as csvf:
        reader = csv.reader(csvf)
        for row in reader:
            li.append(row)

    for i in li:
        dic.update({i[0]: i[1]})
    return dic


def changeKS(FusionOS, ip, hostName):
    file_data = """#version=DEVEL
# Use graphical install
graphical
#Use http installation source
url --url=http://ip/FusionOS/  

%packages
@^server-product-environment                   
 
%end
 
#add
 
# Root password
rootpw --iscrypted 
"""

    commandSyn("mkdir -m 755 /var/www/html/ks/")
    with open(FusionOS, "w", encoding="utf-8") as f:
        f.write(file_data)

    while 1:
        passwordInput = getpass.getpass("Please enter root password you want： ")
        passwordInput2 = getpass.getpass("Please enter it again: ")
        if passwordInput == passwordInput2:
            logging.info("successfully")
            break
        else:
            logging.info("two inputs are inconsistent , please try again")
    passwordOutput = crypt.crypt(passwordInput)
    alterAfter(FusionOS, "rootpw --iscrypted", " " + passwordOutput)

    # Modify the configuration according to the csv file
    dic2 = readCsv('/etc/auto-pxe/ks_cfg.csv')
    s = "http://%s/FusionOS/\n" % ip
    alterAfter(FusionOS, "url --url=", s)

    # The following are custom configurations
    data_ks = ""
    for _, v in dic2.items():
        if v != "":
            data_ks += v
            data_ks += '\n'

    alterAfter(FusionOS, "add\n", data_ks)


def x86grub(ip, isoName):
    files = getFileByPath('/mnt/images/pxeboot/')
    for i in files:
        file = "cp -r /mnt/images/pxeboot/%s /var/lib/tftpboot/" % i
        commandSyn(file)

    commandSyn("cp /mnt/EFI/BOOT/BOOTX64.EFI /var/lib/tftpboot/")
    commandSyn("cp /mnt/EFI/BOOT/grubx64.efi /var/lib/tftpboot/")
    commandSyn("cp /mnt/EFI/BOOT/grub.cfg /var/lib/tftpboot/")
    commandSyn("mkdir -m 755 -p /var/lib/tftpboot/images/pxeboot")
    commandSyn("cp /var/lib/tftpboot/vmlinuz /var/lib/tftpboot/images/pxeboot")
    commandSyn("cp /var/lib/tftpboot/initrd.img /var/lib/tftpboot/images/pxeboot")
    chmodByfile("/var/lib/tftpboot/images")

    grub = "/var/lib/tftpboot/grub.cfg"
    alter(grub, '''set default="1"''', '''set default="0"''')
    s = " '%s' \n" % isoName[:-4]
    alterAfter(grub, "search --no-floppy --set=root -l", s)

    addIp = "        set root=(tftp,%s)\n" % ip
    addAfter(grub, "menuentry 'Install FusionOS 23'", addIp)
    addAfter(grub, "menuentry 'Test this media & install FusionOS", addIp)
    s = " quiet inst.ks=http://%s/ks/FusionOS-ks.cfg\n" % ip
    alterAfter(grub, "linuxefi /images/pxeboot/vmlinuz", s)


def armgrub(ip, isoName):
    files = getFileByPath('/mnt/images/pxeboot/')
    for i in files:
        file = "cp -r /mnt/images/pxeboot/%s /var/lib/tftpboot/" % i
        commandSyn(file)

    commandSyn("cp /mnt/EFI/BOOT/BOOTAA64.EFI /var/lib/tftpboot/")
    commandSyn("cp /mnt/EFI/BOOT/grubaa64.efi /var/lib/tftpboot/")
    commandSyn("cp /mnt/EFI/BOOT/grub.cfg /var/lib/tftpboot/")
    commandSyn("mkdir -m 755 -p /var/lib/tftpboot/images/pxeboot")
    commandSyn("cp /var/lib/tftpboot/vmlinuz /var/lib/tftpboot/images/pxeboot")
    commandSyn("cp /var/lib/tftpboot/initrd.img /var/lib/tftpboot/images/pxeboot")
    chmodByfile("/var/lib/tftpboot/images")

    grub = "/var/lib/tftpboot/grub.cfg"
    alter(grub, '''set default="1"''', '''set default="0"''')
    s = " %s \n" % isoName[:-4]
    alterAfter(grub, "search --no-floppy --set=root -l", s)
    addIp = "        set root=(tftp,%s)\n" % ip
    addAfter(grub, "menuentry 'Install FusionOS 23'", addIp)
    addAfter(grub, "menuentry 'Test this media & install FusionOS", addIp)
    s = "@60me inst.ks=http://%s/ks/FusionOS-ks.cfg\n" % ip
    alterAfter(grub, "@60me", s)

    alter(grub, "inst.stage2=hd:LABEL=FusionOS-23-aarch64", "")


def addYumFromIso():
    iso = "/home/FusionOS"
    fileNames = getFileByPath(iso)
    isoName = ""
    tarName = ""
    isoNum, tarNum = 0, 0
    for s in fileNames:
        if s[-3:] == "iso":
            isoName = s
            isoNum += 1
        if s[-2:] == "gz":
            tarName = s
            tarNum += 1
    if isoNum == 0:
        logging.info("iso does not exist in the /home/FusionOS, is the path wrong or forgot to import?")
    if tarNum == 0:
        logging.info("The tar package does not exist in the /home/FusionOS, is it a wrong path or forgot to import?")
    if isoNum > 1:
        logging.info("There are multiple iso, the last one will be selected as the default")
    if tarNum > 1:
        logging.info("There are multiple tar, the last one will be selected as the default")

    if isoName[-11:-4] == "aarch64":
        logging.info("After judgment, the server version is arm64")
    else:
        logging.info("After judgment, the server version is x86")
    chmodByfile('/mnt')
    chmodByfile('/home/FusionOS/')

    s2 = 'mkdir -m 755 -p /home/FusionOS/srv/repo/'
    s3 = 'cp -r /mnt/Packages /home/FusionOS/srv/repo/'
    s4 = 'cp -r /mnt/repodata /home/FusionOS/srv/repo'
    s5 = 'cp -r /mnt/RPM-GPG-KEY-FusionOS /home/FusionOS/srv/repo/'
    s = 'mount /home/FusionOS/%s /mnt/' % isoName
    commandSyn(s)
    commandSyn(s2)
    commandSyn(s3)
    commandSyn(s4)
    commandSyn(s5)
    file = "/etc/yum.repos.d/FusionOS.repo"
    file_data = '''[base]
name=base
baseurl=file:///home/FusionOS/srv/repo
enabled=1
gpgcheck=1
gpgkey=file:///home/FusionOS/srv/repo/RPM-GPG-KEY-FusionOS
[update]
name=update
baseurl=file:///home/FusionOS/srv/update/
enabled=0
gpgcheck=1
gpgkey=file:///home/FusionOS/srv/repo/RPM-GPG-KEY-FusionOS '''

    insert(file, file_data)
    if tarNum >= 1:
        commandSyn('mkdir -m 755 -p /home/FusionOS/srv/update')
        s = 'tar -xf /home/FusionOS/%s -C /home/FusionOS/srv/update' % tarName
        commandSyn(s)
        commandSyn('dnf install createrepo -y')
        commandSyn('createrepo /home/FusionOS/srv/update')

        alter(file, "enabled=0", "enabled=1")


# if client is in secureboot mode, modify filename from grubx64.efi(grubaa64.efi) to BOOTX64.EFI(BOOTAA64.EFI)
def addDHCP(ip, version):
    commandSyn("dnf install dhcp -y")
    commandSyn("cp /usr/share/doc/dhcp-server/dhcpd.conf.example /etc/dhcp/dhcpd.conf")
    chmodByfile("/etc/dhcp/dhcpd.conf")

    dhcpd = "/etc/dhcp/dhcpd.conf"
    file = '''# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp-server/dhcpd.conf.example
#   see dhcpd.conf(5) man page
#
ddns-update-style interim;
ignore client-updates;

subnet 192.168.122.0 netmask 255.255.255.0 { 
    option routers 192.168.122.1; 
    option subnet-mask 255.255.255.0; 
    range dynamic-bootp 192.168.122.50 192.168.122.200;  
    default-lease-time 21600; 
    max-lease-time 43200; 
    filename "grubx64.efi";
    next-server 192.168.122.1;
}'''
    with open(dhcpd, "w", encoding="utf-8") as f:
        f.write(file)
        f.close()

    dic = readCsv("/etc/auto-pxe/network.csv")
    try:
        routers = dic["routers"]
        netmask = dic["netmask"]
        dynamicBootp = dic["dynamicBootp"]
        subnet = dic["subnet"]
    except KeyError:
        logging.info("Network configuration missing entries, please fill in")
    if version == 1:
        filename = "grubaa64.efi"
    else:
        filename = "grubx64.efi"
    alter(dhcpd, "192.168.122.0", subnet)
    alter(dhcpd, "255.255.255.0", netmask)
    alterAfter(dhcpd, "option routers ", routers + ';\n')
    alterAfter(dhcpd, "option subnet-mask ", netmask + ';\n')
    alterAfter(dhcpd, "range dynamic-bootp ", dynamicBootp + ';\n')
    s = ''' "%s";\n''' % filename
    alterAfter(dhcpd, "filename ", s)
    alterAfter(dhcpd, "next-server ", ip + ';\n')
    commandSyn("systemctl start dhcpd")
    commandSyn("systemctl enable dhcpd")


def getFileByPath(path):
    output = subs.check_output(['/usr/bin/ls', '%s' % path])
    output = output.decode()[:-1]
    files = output.split("\n")
    return files


def chmodByfile(path):
    s = 'chmod -R 755 %s' % path
    commandSyn(s)


def commandSyn(command):
    li = command.split(' ')
    p = subs.run(li)
