# coding:utf-8
import crypt
import socket
import traceback
import logging
from inspect import trace
import subprocess as subs

import pxe_fuction

# The attribute that needs to be written

logging.basicConfig(level=logging.INFO)

# First empty the previous configuration
pxe_fuction.commandSyn("rm -rf /var/lib/tftpboot/*")

# Returns the system hostname where Python is currently executing
hostName = socket.gethostname()
dic = pxe_fuction.readCsv("/etc/auto-pxe/network.csv")
try:
    ip = dic["ip"]
except KeyError:
    logging.info("network.csv does not exist in the file IP, please fill in")

iso = "/home/clientFusionOS"
fileNames = pxe_fuction.getFileByPath(iso)
isoName = ""
tarName = ""
isoNum, tarNum = 0, 0
for s in fileNames:
    if s[-3:] == "iso":
        isoName = s
        isoNum += 1
version = 0
# Check the iso and tar imports
if isoNum == 0:
    logging.info("iso does not exist in the /home/clientFusionOS folder, is the path wrong or forgot to import?")
    logging.info("The script is incorrect")
if isoNum > 1:
    logging.info("There are multiple isos, the last one will be selected as the default")

# 5.2 To make a judgment, version is version, 0 is x86, and 1 is arm
if isoName[-11:-4] == "aarch64":
    version = 1  # 1为arm版本
    logging.info("The client version is arm64")
else:
    logging.info("The client version is x86")

# 6
# 6.2 Upload iso as the yum source
try:
    pxe_fuction.addYumFromIso()
except BaseException:
    traceback.logging.info_exc()
    logging.info("Yum source configuration failed, script error")
logging.info("The yum source is configured successfully")

# 7.Turn off the firewall
try:
    pxe_fuction.commandSyn("systemctl stop firewalld")
except BaseException:
    traceback.logging.info_exc()
    logging.info("Firewall shutdown failed with incorrect script")
logging.info("The firewall is turned off")

# 8.1.disposition httpd
pxe_fuction.commandSyn("dnf install httpd -y")


welcome = '/etc/httpd/conf.d/welcome.conf'
pxe_fuction.alter(welcome, "Options -Indexes", "")
logging.info("The options were deleted successfully and the httpd configuration was successful")
pxe_fuction.commandSyn("systemctl start httpd")
pxe_fuction.commandSyn("systemctl enable httpd")
logging.info("The httpd configuration is complete")

# 8.2.Configure tftp
# Install dnf

pxe_fuction.commandSyn("dnf install tftp-server -y")
tftpName = "/etc/xinetd.d/tftp"
pxe_fuction.alter(tftpName, "disable\t\t\t= yes", "disable\t\t\t= no")
pxe_fuction.commandSyn("systemctl start tftp")
pxe_fuction.commandSyn("systemctl enable tftp")
logging.info("The tftp configuration is successful")


pxe_fuction.commandSyn("umount /mnt")
s = "mount /home/clientFusionOS/%s /mnt/" % isoName
pxe_fuction.commandSyn(s)

pxe_fuction.commandSyn("rm -rf /var/www/html/FusionOS/")
pxe_fuction.commandSyn("mkdir -m 755 /var/www/html/FusionOS")
files = pxe_fuction.getFileByPath('/mnt/')
for i in files:
    s = 'cp -r /mnt/%s /var/www/html/FusionOS/' % i
    pxe_fuction.commandSyn(s)

logging.info("The tftp configuration is complete")

# 11 , 12 Modify the kickstart configuration file FusionOS-ks.cfg
FusionOS = "/var/www/html/ks/FusionOS-ks.cfg"

pxe_fuction.changeKS(FusionOS, ip, hostName)
logging.info("FusionOS-ks.cfg file modification successfully")

# 13 Automatically modify the pxe configuration file grub.cfg
if version == 0:
    pxe_fuction.x86grub(ip, isoName)
else:
    pxe_fuction.armgrub(ip, isoName)
logging.info("grub.cfg file modified successfully")

# 14 DHCP configuration

pxe_fuction.addDHCP(ip, version)

pxe_fuction.commandSyn("umount /mnt")
logging.info("The DHCP configuration is successful and the script is executed")
